﻿using System;
using System.Threading;
using SimpleProgress.Framework;

namespace SimpleProgress.Controllers
{
    public class TaskController : SimpleProgressController
    {
        public String DoWork(Int32 repeat)
        {
            var taskId = GetTaskId(); 
            for (var i = 1; i <= repeat; i++)
            {
                ProgressManager.SetCompleted(taskId, String.Format("Iteration #{0} completed...", i));
                Thread.Sleep(1000);
            }

            // Some return value
            return String.Format("Task completed @{0}", DateTime.Now.ToString("h:mm:ss"));
        }

        public String BookFlight(String from, String to)
        {
            var taskId = GetTaskId();
            
            // Book first leg
            ProgressManager.SetCompleted(taskId, String.Format("{2} || Booking flight: {0}-{1} ...", from, to, taskId));
            Thread.Sleep(2000);

            // Book return 
            ProgressManager.SetCompleted(taskId, String.Format("{2} || Booking flight: {0}-{1} ...", to, from, taskId));
            Thread.Sleep(1000);

            // Book return 
            ProgressManager.SetCompleted(taskId, String.Format("{0} || Paying for the flight ...", taskId));
            Thread.Sleep(2000);

            // Some return value
            return String.Format("{0} || Flight booked successfully", taskId); 
        }
    }
}
