using System;
using System.Web;
using System.Web.Caching;
using SimpleProgress.Framework.Abstractions;

namespace SimpleProgress.Framework
{
    public class AspnetProgressProvider : IProgressDataProvider
    {
        public void Set(String taskId, String progress, Int32 durationInSeconds=5)
        {
            HttpContext.Current.Cache.Insert(
                taskId,
                progress,
                null,
                DateTime.Now.AddSeconds(durationInSeconds),
                Cache.NoSlidingExpiration);
        }

        public String Get(String taskId)
        {
            var o = HttpContext.Current.Cache[taskId];
            if (o == null)
                return String.Empty;

            return (String) o;
        }
    }
}